## API Report File for "@fluidframework/odsp-doclib-utils"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { DriverErrorTelemetryProps } from '@fluidframework/driver-utils/internal';
import { IFluidErrorBase } from '@fluidframework/telemetry-utils/internal';
import { IOdspErrorAugmentations } from '@fluidframework/odsp-driver-definitions/internal';
import type { ITelemetryBaseProperties } from '@fluidframework/core-interfaces';
import { LoggingError } from '@fluidframework/telemetry-utils/internal';
import { OdspError } from '@fluidframework/odsp-driver-definitions/internal';

// @internal
export function authRequestWithRetry(authRequestInfo: IOdspAuthRequestInfo, requestCallback: (config: RequestInit) => Promise<Response>): Promise<Response>;

// @internal (undocumented)
export function createOdspNetworkError(errorMessage: string, statusCode: number, retryAfterSeconds?: number, response?: Response, responseText?: string, props?: ITelemetryBaseProperties): IFluidErrorBase & OdspError;

// @internal (undocumented)
export function enrichOdspError(error: IFluidErrorBase & OdspError, response?: Response, facetCodes?: string[], props?: ITelemetryBaseProperties): IFluidErrorBase & OdspError;

// @internal (undocumented)
export const fetchIncorrectResponse = 712;

// @internal
export function fetchTokens(server: string, scope: string, clientConfig: IPublicClientConfig, credentials: TokenRequestCredentials): Promise<IOdspTokens>;

// @internal (undocumented)
export function getAadTenant(server: string): string;

// @internal (undocumented)
export function getAadUrl(server: string): string;

// @internal (undocumented)
export function getAsync(url: string, authRequestInfo: IOdspAuthRequestInfo): Promise<Response>;

// @internal (undocumented)
export function getChildrenByDriveItem(driveItem: IOdspDriveItem, server: string, authRequestInfo: IOdspAuthRequestInfo): Promise<IOdspDriveItem[]>;

// @alpha (undocumented)
export function getDriveId(server: string, account: string, library: string | undefined, authRequestInfo: IOdspAuthRequestInfo): Promise<string>;

// @internal (undocumented)
export function getDriveItemByRootFileName(server: string, account: string | undefined, path: string, authRequestInfo: IOdspAuthRequestInfo, create: boolean, driveId?: string): Promise<IOdspDriveItem>;

// @internal (undocumented)
export function getDriveItemByServerRelativePath(server: string, serverRelativePath: string, authRequestInfo: IOdspAuthRequestInfo, create: boolean): Promise<IOdspDriveItem>;

// @internal (undocumented)
export function getDriveItemFromDriveAndItem(server: string, drive: string, item: string, authRequestInfo: IOdspAuthRequestInfo): Promise<IOdspDriveItem>;

// @internal (undocumented)
export function getFetchTokenUrl(server: string): string;

// @internal (undocumented)
export function getLoginPageUrl(server: string, clientConfig: IPublicClientConfig, scope: string, odspAuthRedirectUri: string): string;

// @internal (undocumented)
export const getOdspRefreshTokenFn: (server: string, clientConfig: IPublicClientConfig, tokens: IOdspTokens) => () => Promise<string>;

// @alpha (undocumented)
export const getOdspScope: (server: string) => string;

// @internal (undocumented)
export const getPushRefreshTokenFn: (server: string, clientConfig: IPublicClientConfig, tokens: IOdspTokens) => () => Promise<string>;

// @internal (undocumented)
export const getRefreshTokenFn: (scope: string, server: string, clientConfig: IPublicClientConfig, tokens: IOdspTokens) => () => Promise<string>;

// @internal (undocumented)
export function getServer(tenantId: string): string;

// @internal (undocumented)
export function getSiteUrl(server: string): string;

// @internal (undocumented)
export function getSPOAndGraphRequestIdsFromResponse(headers: {
    get: (id: string) => string | undefined | null;
}): ITelemetryBaseProperties;

// @internal (undocumented)
export function hasFacetCodes(x: any): x is Pick<IOdspErrorAugmentations, "facetCodes">;

// @alpha (undocumented)
export interface IOdspAuthRequestInfo {
    // (undocumented)
    accessToken: string;
    // (undocumented)
    refreshTokenFn?: () => Promise<string>;
}

// @internal (undocumented)
export interface IOdspDriveItem {
    // (undocumented)
    driveId: string;
    // (undocumented)
    isFolder: boolean;
    // (undocumented)
    itemId: string;
    // (undocumented)
    name: string;
    // (undocumented)
    path: string;
}

// @internal (undocumented)
export interface IOdspTokens {
    // (undocumented)
    readonly accessToken: string;
    // (undocumented)
    readonly refreshToken: string;
}

// @internal
export interface IPublicClientConfig {
    // (undocumented)
    clientId: string;
}

// @internal (undocumented)
export function isOdspHostname(server: string): boolean;

// @internal (undocumented)
export function isPushChannelHostname(server: string): boolean;

// @internal
export interface OdspErrorResponse {
    // (undocumented)
    error: OdspErrorResponseInnerError & {
        message: string;
    };
}

// @internal
export interface OdspErrorResponseInnerError {
    // (undocumented)
    code?: string;
    // (undocumented)
    innerError?: OdspErrorResponseInnerError;
}

// @internal
export class OdspRedirectError extends LoggingError implements IFluidErrorBase {
    constructor(message: string, redirectLocation: string | undefined, props: DriverErrorTelemetryProps);
    // (undocumented)
    readonly canRetry = false;
    // (undocumented)
    readonly errorType: "fileNotFoundOrAccessDeniedError";
    // (undocumented)
    readonly redirectLocation: string | undefined;
}

// @internal (undocumented)
export const OdspServiceReadOnlyErrorCode = "serviceReadOnly";

// @internal (undocumented)
export function parseFacetCodes(errorResponse: OdspErrorResponse): string[];

// @internal (undocumented)
export function postAsync(url: string, body: any, authRequestInfo: IOdspAuthRequestInfo): Promise<Response>;

// @alpha (undocumented)
export const pushScope = "offline_access https://pushchannel.1drv.ms/PushChannel.ReadWrite.All";

// @internal (undocumented)
export function putAsync(url: string, authRequestInfo: IOdspAuthRequestInfo): Promise<Response>;

// @internal
export function refreshTokens(server: string, scope: string, clientConfig: IPublicClientConfig, tokens: IOdspTokens): Promise<IOdspTokens>;

// @internal
export function throwOdspNetworkError(errorMessage: string, statusCode: number, response: Response, responseText?: string, props?: ITelemetryBaseProperties): never;

// @internal (undocumented)
export type TokenRequestCredentials = {
    grant_type: "authorization_code";
    code: string;
    redirect_uri: string;
} | {
    grant_type: "refresh_token";
    refresh_token: string;
} | {
    grant_type: "password";
    username: string;
    password: string;
};

// @internal (undocumented)
export function tryParseErrorResponse(response: string | undefined): {
    success: true;
    errorResponse: OdspErrorResponse;
} | {
    success: false;
};

// @internal (undocumented)
export function unauthPostAsync(url: string, body: any): Promise<Response>;

// (No @packageDocumentation comment for this package)

```
